//+------------------------------------------------------------------+
//|                                            Check_OrderLevels.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                     http://forum.mql4.com/ru/69818/page2#1023827 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://forum.mql4.com/ru/69818/page2#1023827"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
bool OrderModifyCheck(int ticket,double price,double sl,double tp)
  {
//---    
   if(OrderSelect(ticket,SELECT_BY_TICKET))
     {
      //---     ,     
      string symbol=OrderSymbol();
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      //---  -      
      bool PriceOpenChanged=true;
      int type=OrderType();
      if(!(type==OP_BUY || type==OP_SELL))
        {
         PriceOpenChanged=(MathAbs(OrderOpenPrice()-price)>point);
        }
      //---  -      StopLoss
      bool StopLossChanged=(MathAbs(OrderStopLoss()-sl)>point);
      //---  -      Takeprofit
      bool TakeProfitChanged=(MathAbs(OrderTakeProfit()-tp)>point);
      //---   -   
      if(PriceOpenChanged || StopLossChanged || TakeProfitChanged)
         return(true);  //         
      //---    , StopLoss  Takeprofit 
      else
      //---   
         PrintFormat(" #%d    Open=%.5f SL=.5f TP=%.5f",
                     ticket,OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
     }
//---   ,    
   return(false);       //    
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---      
   double priceopen,stoploss,takeprofit;
//---    
   int orderticket;
/*
   ...   e    StopLoss/Takeprofit/PriceOpen
*/
//---        
   if(OrderModifyCheck(orderticket,priceopen,stoploss,takeprofit))
     {
      //---   
      OrderModify(orderticket,priceopen,stoploss,takeprofit,OrderExpiration());
     }
  }
//+------------------------------------------------------------------+
